// JtiHorizontal.cpp : Defines the class behaviors for the application.
//
#include "stdafx.h"
#include "JtiHorizontal.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include "JtiHorizontalDoc.h"
#include "JtiHorizontalView.h"
#include "CvTPlotT.h"
#include "RPvTSLPlotT.h"
#include "RPvTLLPlotT.h"
#include "RPvCPlotT.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJtiHorizontalApp

BEGIN_MESSAGE_MAP(CJtiHorizontalApp, CWinAppEx)
	//{{AFX_MSG_MAP(CJtiHorizontalApp)
	//}}AFX_MSG_MAP
	// Standard file based document commands
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJtiHorizontalApp construction

CJtiHorizontalApp::CJtiHorizontalApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	// support Restart Manager
	m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_ALL_ASPECTS;
#ifdef _MANAGED
	// If the application is built using Common Language Runtime support (/clr):
	//     1) This additional setting is needed for Restart Manager support to work properly.
	//     2) In your project, you must add a reference to System.Windows.Forms in order to build.
	System::Windows::Forms::Application::SetUnhandledExceptionMode(System::Windows::Forms::UnhandledExceptionMode::ThrowException);
#endif

}

CJtiHorizontalApp::~CJtiHorizontalApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CJtiHorizontalApp object

CJtiHorizontalApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CJtiHorizontalApp initialization

BOOL DirectoryCheckCreate(CString csPath)
{
	DWORD dw = GetFileAttributes(csPath);
	if (dw == 0xffffffff)
	{
		dw = GetLastError();
		if (dw == ERROR_PATH_NOT_FOUND || dw == ERROR_FILE_NOT_FOUND) CreateDirectory(csPath, NULL);
		else
		{
			CString csErr;
			csErr.Format(_T("Failed to create %s\nError: %d"), (LPCTSTR) csPath, dw);
			AfxMessageBox(csErr, MB_OK | MB_ICONEXCLAMATION);  // Failed to create %1\nError: %2!d!
			return false;
		}
	}
	return true;
}

BOOL CJtiHorizontalApp::InitInstance()
{
	const CString csSrc = _T("JtiHorizontalApp::InitInstance");

	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;

	InitCommonControlsEx(&InitCtrls);

	CWinAppEx::InitInstance();

	// Initialize OLE libraries
	//if (!AfxOleInit())
	//{
	//	AfxMessageBox(IDP_OLE_INIT_FAILED);
	//	return false;
	//}
	
	AfxEnableControlContainer();

	EnableTaskbarInteraction();

	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("JTI"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	InitContextMenuManager();

	InitKeyboardManager();

	InitTooltipManager();
	CMFCToolTipInfo ttParams;
	ttParams.m_bVislManagerTheme = true;
	theApp.GetTooltipManager()->SetTooltipParams(AFX_TOOLTIP_TYPE_ALL,
		RUNTIME_CLASS(CMFCToolTipCtrl), &ttParams);

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.
	
	//  LOOK AT IN FUTURE - MultiLateral gets away with using same Doc class for all templates
	pDocTemplate = new CMultiDocTemplate(
		IDR_MAINFRAME,	// This changes the menu set!
		RUNTIME_CLASS(CJtiHorizontalDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CJtiHorizontalView));
	AddDocTemplate(pDocTemplate);

	pRPTSLDocTemplate = new CMultiDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CJtiHorizontalDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(RPvTSLPlotT));
	AddDocTemplate(pRPTSLDocTemplate);

	pRPvTLLDocTemplate = new CMultiDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CJtiHorizontalDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(RPvTLLPlotT));
	AddDocTemplate(pRPvTLLDocTemplate);

	pCvTDocTemplate = new CMultiDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CJtiHorizontalDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CvTPlotT));
	AddDocTemplate(pCvTDocTemplate);

	pRPvCDocTemplate = new CMultiDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CJtiHorizontalDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(RPvCPlotT));
	AddDocTemplate(pRPvCDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;

	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
	{
		ReportError(csSrc, _T("MainFrame->LoadFrame failed"));
		delete pMainFrame;
		return false;
	}

	m_pMainWnd = pMainFrame; // Do not delete this line, its absence causes a memory leak!

	// Enable DDE Execute open
	EnableShellOpen();

	RegisterShellFileTypes(true);
	
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line.  Will return false if
	// app was launched with /RegServer, /Register, /Unregserver or /Unregister.
	//if (!ProcessShellCommand(cmdInfo))
	//	return false;

	return true;
}

int CJtiHorizontalApp::ExitInstance()
{
	return 0;
}

void CJtiHorizontalApp::ReportError (CString csSrc, int nID)
{
	AfxMessageBox(nID, MB_OK | MB_ICONEXCLAMATION);
}

void CJtiHorizontalApp::ReportError (CString csSrc, CString csErr)
{
	AfxMessageBox(csErr, MB_OK | MB_ICONEXCLAMATION);
}
