#include "stdafx.h"
#include "StarFileParser.h"

char* StarFileParser::GetField(char* input, int& iPos, bool& done)
{
	// Replaces delimiting character with 0 to null terminate the strings
	// are returns the address of the char* string.

	// The input buffer must be terminated with \n
	
	// No assumptions are made about the length of the input buffer, other
	// than it is less then max(int).

	// No copying of character is done.

	// The current code does not discard the \r that may exist
	// before the \n for DOS/Windows format.  It does not appear to be a problem.

	char	*ptInput;

	done = false;
	ptInput = input;

	while((*ptInput != '*') && (*ptInput != '\n'))
	{
		iPos++;
		ptInput++;
		if(*ptInput == '\n') done = true;
	}
	*ptInput = 0;
	iPos++;

	return input;
}

int StarFileParser::SplitString(char* input, vector<char*>& results)
{
	int iFields = 0;
	int iPos = 0;
	bool done = false;

	while (! done)
	{
		results.push_back(StarFileParser::GetField(&input[iPos], iPos, done));
		iFields++;
	}
	return iFields;
}

int StarFileParser::GetNDouble(char* input, const int& numWanted, const int& line, const CString& file, vector<double>& results)
{
	vector<char*> cResults;
	char	*stopstring;

	int iFields = StarFileParser::SplitString(input, cResults);
	
	int iStop = iFields;
	if (numWanted > 0)
		if (numWanted < iFields) iStop = numWanted;

	int iCur;
	int iLength;
	for (iCur=0; iCur<iStop; iCur++)
	{
		results.push_back(strtod(cResults[iCur], &stopstring));
	}

	if (iCur < numWanted)
	{
		for (; iCur<numWanted; iCur++)
		{
			results.push_back(0.0);
		}
	}
	return iCur;
}